<template>
  <div class="sg-page-content">
    <div class="sg-breadcrumb">
      <div class="container">
        <ol class="breadcrumb justify-content-center">
          <li class="breadcrumb-item">
            <router-link :to="{ name : 'cart' }">{{ lang.view_cart }}</router-link>
          </li>
          <li class="breadcrumb-item">{{ lang.check_out }}</li>
          <li class="breadcrumb-item"><a href="javascript:void(0)">{{ lang.confirm_order }}</a></li>
        </ol>
      </div>
    </div><!-- /.sg-breadcrumb -->

    <section class="shopping-cart">
      <div class="container">
        <div class="row">
          <div class="col-lg-8" v-if="true">
            <div class="sg-shipping">
              <div class="title">
                <h1>{{ lang.choose_a_way_to_collect_order }}</h1>
              </div>
              <div class="left-content" v-if="pick_hubs.length > 0">
                <form class="form-checkbox">
                  <div class="form-group">
                    <input type="radio" id="address" value="2"
                           v-model="checkout_method" @change="calculateShippingCost"
                           class="form-check-input">
                    <label for="address">{{ lang.use_shipping_billing_addresses }}</label>

                    <input type="radio" id="pickhub" value="1"
                           v-model="checkout_method" @change="calculateShippingCost"
                           class="form-check-input">
                    <label for="pickhub">{{ lang.use_pickHub_point }}</label>
                  </div>
                </form>
              </div>
              <div v-if="pick_hubs.length > 0 && checkout_method == 1" class="title mt-2">
                <h1>{{ lang.pickHub_point }}</h1>
              </div>

              <div class="left-content" v-if="checkout_method == 1 && pick_hubs.length > 0">
                <select v-model="pick_hub_id" @change="calculateShippingCost" class="form-control">
                  <option value="">{{ lang.select_pickHub_point }}</option>
                  <option v-for="(hub,index) in pick_hubs" :key="index" :value="hub.id">{{ hub.name }}
                    => {{ hub.address }}
                  </option>
                </select>
              </div>

              <div v-if="addresses.length > 0 && checkout_method == 2" class="title mt-2">
                <h1>{{ lang.shipping_address }}</h1>
              </div>
              <div class="row text-capitalize" v-if="addresses && checkout_method == 2">
                <div class="col-lg-6" v-for="(address, index) in addresses" :key="index">
                  <label :id="'shipping_'+address.id" class="address_selector">
                    <div class="sg-card address chekout"
                         :class="default_shipping.id == address.id ? 'selected' : ''">
                      <div class="justify-content-between d-flex">
                        <div class="text d-flex">
                          <div class="float-left">
                            <input class="form-check-input"
                                   type="radio" :value="address"
                                   name="radioNoLabel" :id="'shipping_'+address.id"
                                   v-model="default_shipping" @change="fetchShippingCost"
                                   aria-label="...">
                          </div>
                          <div class="address-right">
                            <ul class="global-list">
                              <li>{{ lang.name }} : {{ address.name }}</li>
                              <li>{{ lang.email }} : {{ address.email }}</li>
                              <li>{{ lang.phone }} : {{ address.phone_no }}</li>
                              <li>{{ lang.street_address }} : {{ address.address }}</li>
                              <li>{{ lang.country }} : {{ address.country }}</li>
                              <li>{{ lang.state }} : {{ address.state }}</li>
                              <li>{{ lang.city }} : {{ address.city }}</li>
                            </ul>
                          </div>
                        </div>
                        <div class="dropdown">
                          <span class="mdi mdi-name mdi-dots-vertical dropbtn"></span>
                          <div class="dropdown-content">
                            <a href="javascript:void(0)"
                               @click="$refs.address_form.edit(address)">{{ lang.edit }}</a>
                            <a href="javascript:void(0)"
                               v-if="!address.default_shipping && !address.default_billing"
                               @click="$refs.address_form.deleteAddress(address.id)">{{ lang.delete }}</a>
                          </div>
                        </div>
                      </div>
                    </div>
                  </label>
                </div>
                <div class="col-lg-12">
                  <div class="form-check" v-if="addresses.length > 0">
                    <input class="form-check-input" v-model="same_address" checked id="same_as"
                           type="checkbox" @change="billingAddressSelect">
                    <label class="form-check-label" for="same_as">
                      {{ lang.address_is_shipping }}
                    </label>
                  </div>
                </div>
              </div><!-- /.accordion -->
              <div v-if="addresses.length > 0 && !same_address && checkout_method == 2" class="title">
                <h1>{{ lang.billing_address }}</h1>
              </div>
              <div class="row text-capitalize" v-if="addresses && !same_address && checkout_method == 2">
                <div class="col-lg-6" v-for="(address, index) in addresses" :key="index">
                  <label :id="'billing_'+address.id" class="address_selector">
                    <div class="sg-card address chekout"
                         :class="default_billing.id == address.id ? 'selected' : ''">
                      <div class="justify-content-between d-flex">
                        <div class="text d-flex">
                          <div class="float-left">
                            <input class="form-check-input"
                                   :checked="default_billing.id == address.id"
                                   type="radio" v-model="default_billing"
                                   :id="'billing_'+address.id" :value="address"
                                   aria-label="...">
                          </div>
                          <div class="address-right">
                            <ul class="global-list">
                              <li>{{ lang.name }} : {{ address.name }}</li>
                              <li>{{ lang.email }} : {{ address.email }}</li>
                              <li>{{ lang.phone }} : {{ address.phone_no }}</li>
                              <li>{{ lang.street_address }} : {{ address.address }}</li>
                              <li>{{ lang.country }} : {{ address.country }}</li>
                              <li>{{ lang.state }} : {{ address.state }}</li>
                              <li>{{ lang.city }} : {{ address.city }}</li>
                            </ul>
                          </div>
                        </div>
                        <div class="dropdown" style="float:right;">
                          <span class="mdi mdi-name mdi-dots-vertical dropbtn"></span>
                          <div class="dropdown-content">
                            <a href="javascript:void(0)"
                               @click="$refs.address_form.edit(address)">{{ lang.edit }}</a>
                            <a href="javascript:void(0)"
                               v-if="!address.default_shipping && !address.default_billing"
                               @click="$refs.address_form.deleteAddress(address.id)">{{ lang.delete }}</a>
                          </div>
                        </div>
                      </div>
                    </div>
                  </label>
                </div>
              </div>
              <addressForm ref="address_form" v-if="checkout_method == 2"/>
            </div><!-- /.sg-shipping -->
          </div>
          <div class="col-lg-8" v-else-if="shimmer">
            <shimmer class="mb-3" :height="200" v-for="(addresses,i) in 3" :key="i"></shimmer>
          </div>
          <div class="col-lg-4 pl-lg-5" v-if="carts">
            <div class="order-summary">
              <h6>{{ lang.price_details }}</h6>
              <coupon v-if="authUser" :coupon_list="coupon_list" :cartList="carts" :trx_id="payment_form.trx_id"></coupon>
              <div class="sg-card">
                <payment_details
                    :sub_total="payment_form.sub_total"
                    :tax="payment_form.tax"
                    :discount_offer="payment_form.discount_offer"
                    :shipping_tax="payment_form.shipping_tax"
                    :coupon_discount="payment_form.coupon_discount"
                    :total="payment_form.total"
                ></payment_details>
              <div class="row my-4">
                <div class="col-6">
                  <button :class="{kk:the_type=='delivery'}" @click="choose='dateTime';the_type='delivery'" style="background-color:#F2E1CF ;border:1px solid #66101F;color:#66101F " class="btn btn-primary">Delivery Time</button>
                </div>
                <div class="col-6">
                  <button :class="{kk:the_type=='repeat'}" @click="choose='repeat';the_type='repeat'" style="background-color:#F2E1CF ;border:1px solid #66101F;color:#66101F " class="btn btn-primary">Frequency  at</button>
                </div>
              </div>
              <div class="row my-1 mx-1" v-if="choose=='repeat'">
                <div class="row mx-1 my-1">
                  <div class="col-3">
                    <button :class="{kk:repeat=='without'}"  @click="repeat='without';isActive=[]" style="background-color:#F2E1CF ;padding:0!important;border:1px solid #66101F;color:#66101F" class="btn btn-primary">Without</button>
                  </div>
                  <div class="col-3">
                    <button :class="{kk:repeat=='daily'}"  @click="repeat='daily';isActive=[]" style="background-color:#F2E1CF ;border:1px solid #66101F;color:#66101F" class="btn btn-primary">Daily</button>
                  </div>
                  <div class="col-3">
                    <button :class="{kk:repeat=='weekly'}" @click="repeat='weekly';isActive=[];isActiveWeek=[];isActiveMonth=[]" style="background-color:#F2E1CF ;border:1px solid #66101F;color:#66101F " class="btn btn-primary">Weekly</button>
                  </div>
                  <div class="col-3">
                    <button :class="{kk:repeat=='monthly'}" @click="repeat='monthly';isActive=[]" style="background-color:#F2E1CF ;padding:0!important;border:1px solid #66101F;color:#66101F " class="btn btn-primary">Monthly</button>
                  </div>
                </div>
                <div class="row my-2 mx-1" v-if="repeat=='weekly'">
                  <div  v-for="(i,index) in week" :key="i" class="col-3 my-1">
                    <button :class="{kk:isActiveWeek.includes(index)}" @click="isActiveWeek.includes(index)?isActiveWeek=isActiveWeek.filter((item)=>item!=index):isActiveWeek.push(index)" style="padding:0 !important;background-color:#F2E1CF;border:1px solid #66101F;color:#66101F" class="btn btn-primary">{{i}}</button>
                  </div>
                </div>
                <div class="row my-2 mx-1" v-if="repeat=='monthly'">
                  <div  v-for="(i,index) in 30" :key="i" class="col-2 my-1">
                    <button :class="{kk:isActiveMonth.includes(index)}" @click="isActiveMonth.includes(index)?isActiveMonth=isActiveMonth.filter((item)=>item!=index):isActiveMonth.push(index)" style="background-color:#F2E1CF;border:1px solid #66101F;color:#66101F" class="btn btn-primary">{{i}}</button>
                  </div>
                </div>
              </div>
              <div class="row" v-if="choose=='dateTime'"> 
                <div class="row mx-1">
                  <div v-if="repeat=='without'" class="col-12">
                    <h6 style="margin-bottom:0 !important">Date:</h6>
                  </div>
                  <div v-if="repeat=='without'" v-for="(j,index) in ten_days" :key="j" class="col-2 my-1">
                    <button :class="{kk:isActive==index}" @click="isActive=index" style="background-color:#F2E1CF;border:1px solid #66101F;color:#66101F" class="btn btn-primary">{{j}}</button>
                  </div>
                </div>
                <div class="row mx-1 mb-2">
                  <div class="col-12">
                    <h6 style="margin-bottom:0 !important;padding-bottom:0 !important;">Time:</h6>
                  </div>
                    <div v-for="(j,index) in times" :key="j" class="col-4 my-1">
                      <button :class="{kk:isActiveTime==index}" @click="isActiveTime=index" style="background-color:#F2E1CF;border:1px solid #66101F;color:#66101F" class="btn btn-primary">{{j}}</button>
                    </div>
                </div>
                <div class="col-12">
                  <h6 style="margin-bottom:0 !important;padding-bottom:0 !important;">Remind Me Before (Hours):</h6>
                  <input type="number" v-model="remind_me" class="form-control">
                </div>
              </div>
                <gdpr_page ref="privacy_agreement" :agreements="settings.privacy_agreement"></gdpr_page>
                <loading_button v-if="loading" :class_name="'btn btn-primary'" style="color:black !important"></loading_button>
                <a href="javascript:void(0)" v-else @click="confirmOrder"
                   class="btn btn-primary" style="color:white !important;background-color: #66101F;">{{ lang.proceed_to_payment }}</a>
              </div>
            </div>
          </div>
        </div><!-- /.row -->
      </div>
    </section><!-- /.shopping-cart -->

  </div>
</template>

<script>
import shimmer from "../partials/shimmer";
import telePhone from "../partials/telephone";
import coupon from "../partials/coupon";
import payment_details from "../partials/payment_details";
import addressForm from "../partials/addressForm";
import gdpr_page from "../partials/gdpr_page";

export default {
  name: "checkout",
  components: {telePhone, shimmer, coupon, payment_details, addressForm, gdpr_page},
  data() {
    return {
      coupon_area: true,
      coupon_list: [],
      checkout: {},
      form: {
        id: '',
        name: '',
        email: '',
        phone_no: '',
        address: '',
        country_id: '',
        state_id: '',
        city_id: '',
        postal_code: '',
      },
      shipping_cost: 0,
      choose:'',
      the_type:'',
      isActiveTime:'',
      address_area: false,
      isActive:[],
      default_shipping: {},
      default_billing: {},
      same_address: true,
      addresses: [],
      pick_hubs: [],
      isActiveMonth:[],
      isActiveWeek:[],
      remind_me:'',
      repeat:'',
      today : new Date(),
      ten_days:[],
      times:['6-10 AM','10-02 PM','02-06 PM','6-10 PM'],
      week:['sunday','monday','tuesday','wednesday','thursday','friday','saturday'],
      pick_hub_id: '',
      checkout_method: 2,
      loading: false,
      save_loading: false,
      address_area_title: 'Add a new address',
      address_submit_button: "Add",
    }
  },
  mounted() {
    this.getAddress();
    this.address_submit_button = this.lang.add;
    for(var i= 1; i < 10; i++) {
        let thisDay = new Date(this.today);
        thisDay.setDate(this.today.getDate() + i);
        this.ten_days.push(thisDay.toISOString().slice(8, 10));
    }

  },
  watch: {
    carts(newValue, oldValue) {
      this.getAddress();
    },
    lang(newValue, oldValue) {
      this.address_submit_button = this.lang.add;

    },
  },
  computed: {
    carts() {
      return this.$store.getters.getCarts;
    },
    shimmer() {
      return this.$store.state.module.shimmer
    }
  },

  methods: {
    getAddress() {
      let url = this.getUrl('user/address?cart_page='+this.$route.query.cart_page);
      this.$Progress.start();
      axios.get(url,{params:this.$route.params.type}).then((response) => {
        if (response.data.error) {
          this.$Progress.fail();
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.$store.commit('setLoginRedirection', '');
          let coupons = response.data.coupons;
          this.parseData(response.data.carts, response.data.checkouts, coupons);
          this.addresses = response.data.addresses;
          this.checkout = response.data.checkout;
          this.pick_hubs = response.data.pickup_hubs;

          for (let i = 0; i < this.addresses.length; i++) {
            if (this.addresses[i].default_shipping == 1) {
              this.default_shipping = this.addresses[i];
            }
            if (this.addresses[i].default_billing == 1) {
              this.default_billing = this.addresses[i];
            }
          }

          if (this.addresses.length === 0) {
            this.address_area = true;
          }

          this.$Progress.finish();
        }
      }).catch((error) => {
        this.$Progress.fail();
      })
    },
    confirmOrder() {
      if (!this.$refs.privacy_agreement.checkAgreements()) {
        return toastr.info(this.lang.accept_terms, this.lang.Error + ' !!');
      }
      this.payment_form.checkout_method = this.checkout_method;
      if (this.checkout_method == 1) {
        if (!this.pick_hub_id) {
          return toastr.info(this.lang.please_choose_a_pickHub_point, this.lang.Error + ' !!');
        }
        this.payment_form.pick_hub_id = this.pick_hub_id;
      } else {
        if (!this.default_shipping.id) {
          return toastr.info(this.lang.please_choose_a_billing_address, this.lang.Error + ' !!');
        }
        this.payment_form.shipping_address = this.default_shipping;
        this.payment_form.billing_address = this.default_billing;
      }

      this.payment_form['buy_now'] = this.$route.params.type ? this.$route.params.type.is_buy_now : 0
      let url = this.getUrl('user/confirm-order');
      this.$Progress.start();
      this.loading = true;


      if(this.repeat!='without'&&this.repeat!='daily'){
        this.payment_form.order_type = 'periodic';
        if(this.repeat=='weekly'){
          this.payment_form.days=this.isActiveWeek;
          this.payment_form.frequency='days_of_week';
          this.payment_form.time=this.isActiveTime
          this.payment_form.remind_before=this.remind_me
        }else if(this.repeat=='monthly'){
          this.payment_form.days=this.isActiveMonth;
          this.payment_form.frequency='days_of_month'
          this.payment_form.time=this.isActiveTime
          this.payment_form.remind_before=this.remind_me
        }
      }
      if(this.repeat=='daily'){
        this.payment_form.order_type = 'periodic';
          this.payment_form.frequency='daily';
          this.payment_form.time=this.isActiveTime;
          this.payment_form.remind_before=this.remind_me
      }
      if(this.repeat=='without'){
        this.payment_form.order_type = 'normal';
        this.payment_form.frequency=null;
          this.payment_form.time=this.isActiveTime;
          this.payment_form.remind_before=this.remind_me
      }
      axios.post(url, this.payment_form).then((response) => {
        this.loading = false;
        if (response.data.error) {
          this.$Progress.fail();
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.$Progress.finish();
          this.$router.push({name: 'payment'});
        }
      }).catch((error) => {
        this.loading = false;
      });
    },
    billingAddressSelect() {
      if (this.same_address) {
        this.default_billing = this.default_shipping;
      } else {
        this.default_billing = {};
      }
    },
    parseData(carts, checkouts, coupons) {
      this.resetForm();
      for (let i = 0; i < carts.length; i++) {
        this.payment_form.quantity.push({id: carts[i].id, quantity: carts[i].quantity});
        this.payment_form.sub_total += parseFloat(carts[i].price * carts[i].quantity);
        this.payment_form.discount_offer += parseFloat(carts[i].discount * carts[i].quantity);
        if (this.settings.shipping_cost == 'product_base') {
          this.payment_form.shipping_tax += parseFloat(carts[i].shipping_cost);
        }
        this.payment_form.tax += parseFloat(carts[i].tax * carts[i].quantity);
        this.payment_form.trx_id = carts[i].trx_id;
      }

      if (checkouts) {
        for (let key in checkouts) {
          this.payment_form.shipping_tax += parseFloat(checkouts[key].shipping_cost);
          this.payment_form.tax += parseFloat(checkouts[key].tax);
        }
      }

      if (coupons && this.settings.coupon_system == 1) {
        this.coupon_list = coupons;
        for (let i = 0; i < coupons.length; i++) {
          this.payment_form.coupon_discount += parseFloat(coupons[i].discount);
        }
      }

      this.shipping_cost = this.payment_form.shipping_tax;

      this.calculateShippingCost();
    },
    fetchShippingCost() {
      this.default_billing = this.default_shipping;
      if (this.settings.shipping_fee_type == 'area_base') {
        let url = this.getUrl('user/find/shipping_cost');

        let form = {
          city_id: this.default_shipping.address_ids.city_id
        };

        axios.post(url, form).then((response) => {
          if (response.data.error) {
            toastr.error(response.data.error, this.lang.Error + ' !!');
          } else {
            this.payment_form.shipping_tax = response.data.shipping_cost;
            this.shipping_cost = this.payment_form.shipping_tax;
            this.payment_form.total = (parseFloat(this.payment_form.sub_total) + parseFloat(this.payment_form.tax) + parseFloat(this.payment_form.shipping_tax)) - (parseFloat(this.payment_form.discount_offer) + parseFloat(this.payment_form.coupon_discount));

            if (this.settings.tax_type == 'after_tax') {
              this.payment_form.total = (parseFloat(this.payment_form.sub_total) + parseFloat(this.payment_form.shipping_tax)) - (parseFloat(this.payment_form.discount_offer) + parseFloat(this.payment_form.coupon_discount));
              this.payment_form.total += this.payment_form.tax;
              if(this.payment_form.total < 0){
                this.payment_form.total = 0;
              }
            } else {
              this.payment_form.total = (parseFloat(this.payment_form.sub_total) + parseFloat(this.payment_form.tax) + parseFloat(this.payment_form.shipping_tax)) - (parseFloat(this.payment_form.discount_offer) + parseFloat(this.payment_form.coupon_discount));
              if(this.payment_form.total < 0){
                this.payment_form.total = 0;
              }
            }
          }
        });
      }
      return false;
    },
    calculateShippingCost() {
      this.payment_form.shipping_tax = 0;
      if (this.checkout_method == 1) {
        this.payment_form.shipping_tax = 0;
      } else {
        this.payment_form.shipping_tax = this.shipping_cost;
      }

      if (this.settings.tax_type == 'after_tax' && this.settings.vat_and_tax_type == 'order_base') {
        this.payment_form.total = (parseFloat(this.payment_form.sub_total) + parseFloat(this.payment_form.shipping_tax)) - (parseFloat(this.payment_form.discount_offer) + parseFloat(this.payment_form.coupon_discount));
        this.payment_form.total += this.payment_form.tax;
        if(this.payment_form.total < 0){
          this.payment_form.total = 0;
        }
      } else {
        this.payment_form.total = (parseFloat(this.payment_form.sub_total) + parseFloat(this.payment_form.tax) + parseFloat(this.payment_form.shipping_tax)) - (parseFloat(this.payment_form.discount_offer) + parseFloat(this.payment_form.coupon_discount));
        if(this.payment_form.total < 0){
          this.payment_form.total = 0;
        }
      }
    },
    getNumber(number) {
      this.form.phone_no = number;
    }
  }
}
</script>
<style scoped>
.kk{
  background-color: #66101F !important;
  color: white !important;
}
</style>
